diff --git a/src/apps/mdns/mdns.c b/src/apps/mdns/mdns.c
index aad272889..f7240fe24 100644
--- a/src/apps/mdns/mdns.c
+++ b/src/apps/mdns/mdns.c
@@ -1751,27 +704,373 @@ mdns_handle_question(struct mdns_packet *pkt)
               break;
             }
             LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Skipping known answer: SRV\n"));
-            reply.serv_replies[i] &= ~REPLY_SERVICE_SRV;
+            reply->serv_replies[i] &= ~REPLY_SERVICE_SRV;
           } while (0);
         } else if (match & REPLY_SERVICE_TXT) {
           mdns_prepare_txtdata(service);
           if (service->txtdata.length == ans.rd_length &&
               pbuf_memcmp(pkt->pbuf, ans.rd_offset, service->txtdata.name, ans.rd_length) == 0) {
             LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Skipping known answer: TXT\n"));
-            reply.serv_replies[i] &= ~REPLY_SERVICE_TXT;
+            reply->serv_replies[i] &= ~REPLY_SERVICE_TXT;
           }
         }
       }
     }
   }
 
-  mdns_send_outpacket(&reply, DNS_FLAG1_RESPONSE | DNS_FLAG1_AUTHORATIVE);
+  return ERR_OK;
+}
 
-cleanup:
-  if (reply.pbuf) {
-    /* This should only happen if we fail to alloc/write question for legacy query */
-    pbuf_free(reply.pbuf);
-    reply.pbuf = NULL;
+/**
+ * Check the incomming packet and parse all authoritative answers to see if the
+ * query is a probe query.
+ *
+ * @param netif network interface of incoming packet
+ * @param pkt   incoming packet
+ * @param reply outgoing message
+ * @return err_t
+ */
+static err_t
+mdns_parse_pkt_authoritative_answers(struct netif *netif, struct mdns_packet *pkt,
+                                     struct mdns_outmsg *reply)
+{
+  struct mdns_host *mdns = NETIF_TO_HOST(netif);
+  struct mdns_service *service;
+  int i;
+  err_t res;
+
+  while (pkt->authoritative_left) {
+    struct mdns_answer ans;
+    u8_t rev_v6;
+    int match;
+
+    res = mdns_read_answer(pkt, &ans, &pkt->authoritative_left);
+    if (res != ERR_OK) {
+      LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Failed to parse answer, skipping query packet\n"));
+      return res;
+    }
+
+    LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Authoritative answer for domain "));
+    mdns_domain_debug_print(&ans.info.domain);
+    LWIP_DEBUGF(MDNS_DEBUG, (" type %d class %d\n", ans.info.type, ans.info.klass));
+
+
+    if (ans.info.type == DNS_RRTYPE_ANY || ans.info.klass == DNS_RRCLASS_ANY) {
+      /* Skip known answers for ANY type & class */
+      continue;
+    }
+
+    rev_v6 = 0;
+    match = reply->host_replies & check_host(netif, &ans.info, &rev_v6);
+    if (match) {
+      reply->probe_query_recv = 1;
+      LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Probe for own host info received\r\n"));
+    }
+
+    for (i = 0; i < MDNS_MAX_SERVICES; i++) {
+      service = mdns->services[i];
+      if (!service) {
+        continue;
+      }
+      match = reply->serv_replies[i] & check_service(service, &ans.info);
+
+      if (match) {
+        reply->probe_query_recv = 1;
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Probe for own service info received\r\n"));
+      }
+    }
+  }
+
+  return ERR_OK;
+}
+
+/**
+ * Add / copy message to delaying message buffer.
+ *
+ * @param dest destination msg struct
+ * @param src  source msg struct
+ */
+static void
+mdns_add_msg_to_delayed(struct mdns_outmsg *dest, struct mdns_outmsg *src)
+{
+  dest->host_questions |= src->host_questions;
+  dest->host_replies |= src->host_replies;
+  dest->host_reverse_v6_replies |= src->host_reverse_v6_replies;
+  for (int i = 0; i < MDNS_MAX_SERVICES; i++) {
+    dest->serv_questions[i] |= src->serv_questions[i];
+    dest->serv_replies[i] |= src->serv_replies[i];
+  }
+
+  dest->flags = src->flags;
+  dest->cache_flush = src->cache_flush;
+  dest->tx_id = src->tx_id;
+  dest->legacy_query = src->legacy_query;
+}
+
+/**
+ * Handle question MDNS packet
+ * 1. Parse all questions and set bits what answers to send
+ * 2. Clear pending answers if known answers are supplied
+ * 3. Define which type of answer is requested
+ * 4. Send out packet or put it on hold until after random time
+ *
+ * @param pkt   incoming packet
+ * @param netif network interface of incoming packet
+ */
+static void
+mdns_handle_question(struct mdns_packet *pkt, struct netif *netif)
+{
+  struct mdns_host *mdns = NETIF_TO_HOST(netif);
+  struct mdns_outmsg reply;
+  u8_t rrs_to_send;
+  u8_t shared_answer = 0;
+  u8_t delay_response = 1;
+  u8_t send_unicast = 0;
+  u8_t listen_to_QU_bit = 0;
+  int i;
+  err_t res;
+
+  if (mdns->probing_state != MDNS_PROBING_COMPLETE) {
+    /* Don't answer questions until we've verified our domains via probing */
+    /* @todo we should check incoming questions during probing for tiebreaking */
+    return;
+  }
+
+  memset(&reply, 0, sizeof(struct mdns_outmsg));
+
+  /* Parse question */
+  res = mdns_parse_pkt_questions(netif, pkt, &reply);
+  if (res != ERR_OK) {
+    return;
+  }
+  /* Parse answers -> count as known answers because it's a question */
+  res = mdns_parse_pkt_known_answers(netif, pkt, &reply);
+  if (res != ERR_OK) {
+    return;
+  }
+  /* Parse authoritative answers -> probing */
+  /* If it's a probe query, we need to directly answer via unicast. */
+  res = mdns_parse_pkt_authoritative_answers(netif, pkt, &reply);
+  if (res != ERR_OK) {
+    return;
+  }
+  /* Ignore additional answers -> do not have any need for them at the moment */
+  if(pkt->additional) {
+    LWIP_DEBUGF(MDNS_DEBUG,
+      ("MDNS: Query contains additional answers -> they are discarded \r\n"));
+  }
+
+  /* Any replies on question? */
+  rrs_to_send = reply.host_replies | reply.host_questions;
+  for (i = 0; i < MDNS_MAX_SERVICES; i++) {
+    rrs_to_send |= reply.serv_replies[i] | reply.serv_questions[i];
+  }
+
+  if (!rrs_to_send) {
+    /* This case is most common */
+    LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Nothing to answer\r\n"));
+    return;
+  }
+
+  reply.flags =  DNS_FLAG1_RESPONSE | DNS_FLAG1_AUTHORATIVE;
+
+  /* Detect if it's a legacy querier asking the question
+   * How to detect legacy DNS query? (RFC6762 section 6.7)
+   *  - source port != 5353
+   *  - a legacy query can only contain 1 question
+   */
+  if (pkt->source_port != LWIP_IANA_PORT_MDNS) {
+    if (pkt->questions == 1) {
+      LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: request from legacy querier\r\n"));
+      reply.legacy_query = 1;
+      reply.tx_id = pkt->tx_id;
+      reply.cache_flush = 0;
+    }
+    else {
+      LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: ignore query if (src UDP port != 5353) && (!= legacy query)\r\n"));
+      return;
+    }
+  }
+  else {
+    reply.cache_flush = 1;
+  }
+
+  /* Delaying response.
+   * Always delay the response, unicast or multicast, except when:
+   *  - Answering to a single question with a unique answer (RFC6762 section 6)
+   *  - Answering to a probe query via unicast (RFC6762 section 6)
+   *
+   * unique answer? -> not if it includes service type or name ptr's
+   */
+  for (i = 0; i < MDNS_MAX_SERVICES; i++) {
+    shared_answer |= (reply.serv_replies[i] &
+                      (REPLY_SERVICE_TYPE_PTR | REPLY_SERVICE_NAME_PTR));
+  }
+  if (((pkt->questions == 1) && (!shared_answer)) || reply.probe_query_recv) {
+    delay_response = 0;
+  }
+  LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: response %s delayed\r\n", (delay_response ? "randomly" : "not")));
+
+  /* Unicast / multicast response:
+   * Answering to (m)DNS querier via unicast response.
+   * When:
+   *  a) Unicast reply requested && recently multicasted 1/4ttl (RFC6762 section 5.4)
+   *  b) Direct unicast query to port 5353 (RFC6762 section 5.5)
+   *  c) Reply to Legacy DNS querier (RFC6762 section 6.7)
+   *  d) A probe message is received (RFC6762 section 6)
+   */
+
+#if LWIP_IPV6
+  if ((IP_IS_V6_VAL(pkt->source_addr) && mdns->ipv6.multicast_timeout_25TTL)) {
+    listen_to_QU_bit = 1;
+  }
+#endif
+#if LWIP_IPV4
+  if ((IP_IS_V4_VAL(pkt->source_addr) && mdns->ipv4.multicast_timeout_25TTL)) {
+    listen_to_QU_bit = 1;
+  }
+#endif
+  if (   (reply.unicast_reply_requested && listen_to_QU_bit)
+      || pkt->recv_unicast
+      || reply.legacy_query
+      || reply.probe_query_recv ) {
+    send_unicast = 1;
+  }
+  LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: send response via %s\r\n", (send_unicast ? "unicast" : "multicast")));
+
+  /* Send out or put on waiting list */
+  if (delay_response) {
+    if (send_unicast) {
+#if LWIP_IPV6
+      /* Add answers to IPv6 waiting list if:
+       *  - it's a IPv6 incoming packet
+       *  - no message is in it yet
+       */
+      if (IP_IS_V6_VAL(pkt->source_addr) && !mdns->ipv6.unicast_msg_in_use) {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: add answers to unicast IPv6 waiting list\r\n"));
+        SMEMCPY(&mdns->ipv6.delayed_msg_unicast.dest_addr, &pkt->source_addr, sizeof(ip_addr_t));
+        mdns->ipv6.delayed_msg_unicast.dest_port = pkt->source_port;
+
+        mdns_add_msg_to_delayed(&mdns->ipv6.delayed_msg_unicast, &reply);
+
+        mdns_set_timeout(netif, MDNS_RESPONSE_DELAY, mdns_send_unicast_msg_delayed_ipv6,
+                         &mdns->ipv6.unicast_msg_in_use);
+      }
+#endif
+#if LWIP_IPV4
+      /* Add answers to IPv4 waiting list if:
+       *  - it's a IPv4 incoming packet
+       *  - no message is in it yet
+       */
+      if (IP_IS_V4_VAL(pkt->source_addr) && !mdns->ipv4.unicast_msg_in_use) {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: add answers to unicast IPv4 waiting list\r\n"));
+        SMEMCPY(&mdns->ipv4.delayed_msg_unicast.dest_addr, &pkt->source_addr, sizeof(ip_addr_t));
+        mdns->ipv4.delayed_msg_unicast.dest_port = pkt->source_port;
+
+        mdns_add_msg_to_delayed(&mdns->ipv4.delayed_msg_unicast, &reply);
+
+        mdns_set_timeout(netif, MDNS_RESPONSE_DELAY, mdns_send_unicast_msg_delayed_ipv4,
+                         &mdns->ipv4.unicast_msg_in_use);
+      }
+#endif
+    }
+    else {
+#if LWIP_IPV6
+      /* Add answers to IPv6 waiting list if:
+       *  - it's a IPv6 incoming packet
+       *  - and the 1 second timeout is passed (RFC6762 section 6)
+       */
+      if (IP_IS_V6_VAL(pkt->source_addr) && !mdns->ipv6.multicast_timeout) {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: add answers to multicast IPv6 waiting list\r\n"));
+
+        mdns_add_msg_to_delayed(&mdns->ipv6.delayed_msg_multicast, &reply);
+
+        mdns_set_timeout(netif, MDNS_RESPONSE_DELAY, mdns_send_multicast_msg_delayed_ipv6,
+                         &mdns->ipv6.multicast_msg_waiting);
+      }
+#endif
+#if LWIP_IPV4
+      /* Add answers to IPv4 waiting list if:
+       *  - it's a IPv4 incoming packet
+       *  - and the 1 second timeout is passed (RFC6762 section 6)
+       */
+      if (IP_IS_V4_VAL(pkt->source_addr) && !mdns->ipv4.multicast_timeout) {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: add answers to multicast IPv4 waiting list\r\n"));
+
+        mdns_add_msg_to_delayed(&mdns->ipv4.delayed_msg_multicast, &reply);
+
+        mdns_set_timeout(netif, MDNS_RESPONSE_DELAY, mdns_send_multicast_msg_delayed_ipv4,
+                         &mdns->ipv4.multicast_msg_waiting);
+      }
+#endif
+    }
+  }
+  else {
+    if (send_unicast) {
+      /* Copy source IP/port to use when responding unicast */
+      SMEMCPY(&reply.dest_addr, &pkt->source_addr, sizeof(ip_addr_t));
+      reply.dest_port = pkt->source_port;
+      /* send answer directly via unicast */
+      res = mdns_send_outpacket(&reply, netif);
+      if (res != ERR_OK) {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Unicast answer could not be send\r\n"));
+      }
+      else {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Unicast answer send successfully\r\n"));
+      }
+      return;
+    }
+    else {
+      /* Set IP/port to use when responding multicast */
+#if LWIP_IPV6
+      if (IP_IS_V6_VAL(pkt->source_addr)) {
+        if (mdns->ipv6.multicast_timeout) {
+          LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: we just multicasted, ignore question\r\n"));
+          return;
+        }
+        SMEMCPY(&reply.dest_addr, &v6group, sizeof(ip_addr_t));
+      }
+#endif
+#if LWIP_IPV4
+      if (IP_IS_V4_VAL(pkt->source_addr)) {
+        if (mdns->ipv4.multicast_timeout) {
+          LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: we just multicasted, ignore question\r\n"));
+          return;
+        }
+        SMEMCPY(&reply.dest_addr, &v4group, sizeof(ip_addr_t));
+      }
+#endif
+      reply.dest_port = LWIP_IANA_PORT_MDNS;
+      /* send answer directly via multicast */
+      res = mdns_send_outpacket(&reply, netif);
+      if (res != ERR_OK) {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Multicast answer could not be send\r\n"));
+      }
+      else {
+        LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Multicast answer send successfully\r\n"));
+#if LWIP_IPV6
+        if (IP_IS_V6_VAL(pkt->source_addr)) {
+          mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT, mdns_multicast_timeout_reset_ipv6,
+                           &mdns->ipv6.multicast_timeout);
+          LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout started - IPv6\n"));
+          mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT_25TTL, mdns_multicast_timeout_25ttl_reset_ipv6,
+                           &mdns->ipv6.multicast_timeout_25TTL);
+          LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout 1/4 of ttl started - IPv6\n"));
+        }
+#endif
+#if LWIP_IPV4
+        if (IP_IS_V4_VAL(pkt->source_addr)) {
+          mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT, mdns_multicast_timeout_reset_ipv4,
+                           &mdns->ipv4.multicast_timeout);
+          LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout started - IPv4\n"));
+          mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT_25TTL, mdns_multicast_timeout_25ttl_reset_ipv4,
+                           &mdns->ipv4.multicast_timeout_25TTL);
+          LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout 1/4 of ttl started - IPv4\n"));
+        }
+#endif
+      }
+      return;
+    }
   }
 }
 
@@ -1780,9 +1079,15 @@ cleanup:
  * Only prints debug for now. Will need more code to do conflict resolution.
  */
 static void
-mdns_handle_response(struct mdns_packet *pkt)
+mdns_handle_response(struct mdns_packet *pkt, struct netif *netif)
 {
-  struct mdns_host* mdns = NETIF_TO_HOST(pkt->netif);
+  struct mdns_host* mdns = NETIF_TO_HOST(netif);
+
+  /* Ignore responses with a source port different from 5353
+   * (LWIP_IANA_PORT_MDNS) -> RFC6762 section 6 */
+  if (pkt->source_port != LWIP_IANA_PORT_MDNS) {
+    return;
+  }
 
   /* Ignore all questions */
   while (pkt->questions_left) {
@@ -1800,7 +1105,7 @@ mdns_handle_response(struct mdns_packet *pkt)
     struct mdns_answer ans;
     err_t res;
 
-    res = mdns_read_answer(pkt, &ans);
+    res = mdns_read_answer(pkt, &ans, &pkt->answers_left);
     if (res != ERR_OK) {
       LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: Failed to parse answer, skipping response packet\n"));
       return;
@@ -1836,9 +1141,9 @@ mdns_handle_response(struct mdns_packet *pkt)
       }
 
       if (conflict != 0) {
-        sys_untimeout(mdns_probe, pkt->netif);
+        sys_untimeout(mdns_probe, netif);
         if (mdns_name_result_cb != NULL) {
-          mdns_name_result_cb(pkt->netif, MDNS_PROBING_CONFLICT);
+          mdns_name_result_cb(netif, MDNS_PROBING_CONFLICT);
         }
       }
     }
@@ -1881,18 +1186,30 @@ mdns_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr,
   memset(&packet, 0, sizeof(packet));
   SMEMCPY(&packet.source_addr, addr, sizeof(packet.source_addr));
   packet.source_port = port;
-  packet.netif = recv_netif;
   packet.pbuf = p;
   packet.parse_offset = offset;
   packet.tx_id = lwip_ntohs(hdr.id);
   packet.questions = packet.questions_left = lwip_ntohs(hdr.numquestions);
-  packet.answers = packet.answers_left = lwip_ntohs(hdr.numanswers) + lwip_ntohs(hdr.numauthrr) + lwip_ntohs(hdr.numextrarr);
-
+  packet.answers = packet.answers_left = lwip_ntohs(hdr.numanswers);
+  packet.authoritative = packet.authoritative_left = lwip_ntohs(hdr.numauthrr);
+  packet.additional = packet.additional_left = lwip_ntohs(hdr.numextrarr);
+
+  /*  Source address check (RFC6762 section 11) -> for responses.
+   *  Source address check (RFC6762 section 5.5) -> for queries.
+   *  When the dest addr == multicast addr we know the packet originated on that
+   *  link. If not, we need to check the source address. We only accept queries
+   *  that originated on the link. Others are discarded.
+   */
 #if LWIP_IPV6
   if (IP_IS_V6(ip_current_dest_addr())) {
     /* instead of having one 'v6group' per netif, just compare zoneless here */
     if (!ip_addr_cmp_zoneless(ip_current_dest_addr(), &v6group)) {
       packet.recv_unicast = 1;
+
+      if (ip6_addr_ismulticast_global(ip_2_ip6(ip_current_src_addr()))
+          || ip6_addr_isglobal(ip_2_ip6(ip_current_src_addr()))) {
+        goto dealloc;
+      }
     }
   }
 #endif
@@ -1900,14 +1217,20 @@ mdns_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr,
   if (!IP_IS_V6(ip_current_dest_addr())) {
     if (!ip_addr_cmp(ip_current_dest_addr(), &v4group)) {
       packet.recv_unicast = 1;
+
+      if (!ip4_addr_netcmp(ip_2_ip4(ip_current_src_addr()),
+                          netif_ip4_addr(recv_netif),
+                          netif_ip4_netmask(recv_netif))){
+           goto dealloc;
+         }
     }
   }
 #endif
 
   if (hdr.flags1 & DNS_FLAG1_RESPONSE) {
-    mdns_handle_response(&packet);
+    mdns_handle_response(&packet, recv_netif);
   } else {
-    mdns_handle_question(&packet);
+    mdns_handle_question(&packet, recv_netif);
   }
 
 dealloc:
@@ -1948,46 +1271,36 @@ static err_t
 mdns_send_probe(struct netif* netif, const ip_addr_t *destination)
 {
   struct mdns_host* mdns;
-  struct mdns_outpacket pkt;
-  struct mdns_domain domain;
+  struct mdns_outmsg outmsg;
   u8_t i;
   err_t res;
 
   mdns = NETIF_TO_HOST(netif);
 
-  memset(&pkt, 0, sizeof(pkt));
-  pkt.netif = netif;
+  memset(&outmsg, 0, sizeof(outmsg));
 
   /* Add unicast questions with rtype ANY for all our desired records */
-  mdns_build_host_domain(&domain, mdns);
-  res = mdns_add_question(&pkt, &domain, DNS_RRTYPE_ANY, DNS_RRCLASS_IN, 1);
-  if (res != ERR_OK) {
-    goto cleanup;
-  }
-  pkt.questions++;
+  outmsg.host_questions = QUESTION_PROBE_HOST_ANY;
+
   for (i = 0; i < MDNS_MAX_SERVICES; i++) {
     struct mdns_service* service = mdns->services[i];
     if (!service) {
       continue;
     }
-    mdns_build_service_domain(&domain, service, 1);
-    res = mdns_add_question(&pkt, &domain, DNS_RRTYPE_ANY, DNS_RRCLASS_IN, 1);
-    if (res != ERR_OK) {
-      goto cleanup;
-    }
-    pkt.questions++;
+    outmsg.serv_questions[i] = QUESTION_PROBE_SERVICE_NAME_ANY;
   }
 
   /* Add answers to the questions above into the authority section for tiebreaking */
 #if LWIP_IPV4
   if (!ip4_addr_isany_val(*netif_ip4_addr(netif))) {
-    pkt.host_replies = REPLY_HOST_A;
+    outmsg.host_replies = REPLY_HOST_A | REPLY_HOST_PTR_V4;
   }
 #endif
 #if LWIP_IPV6
   for (i = 0; i < LWIP_IPV6_NUM_ADDRESSES; i++) {
     if (ip6_addr_isvalid(netif_ip6_addr_state(netif, i))) {
-      pkt.host_replies |= REPLY_HOST_AAAA;
+      outmsg.host_replies |= REPLY_HOST_AAAA | REPLY_HOST_PTR_V6;
+      outmsg.host_reverse_v6_replies |= (1 << i);
     }
   }
 #endif
@@ -1995,20 +1308,16 @@ mdns_send_probe(struct netif* netif, const ip_addr_t *destination)
   for (i = 0; i < MDNS_MAX_SERVICES; i++) {
     struct mdns_service *serv = mdns->services[i];
     if (serv) {
-      pkt.serv_replies[i] = REPLY_SERVICE_SRV | REPLY_SERVICE_TXT;
+      outmsg.serv_replies[i] = REPLY_SERVICE_SRV | REPLY_SERVICE_TXT
+                            | REPLY_SERVICE_TYPE_PTR | REPLY_SERVICE_NAME_PTR;
     }
   }
 
-  pkt.tx_id = 0;
-  pkt.dest_port = LWIP_IANA_PORT_MDNS;
-  SMEMCPY(&pkt.dest_addr, destination, sizeof(pkt.dest_addr));
-  res = mdns_send_outpacket(&pkt, 0);
+  outmsg.tx_id = 0;
+  outmsg.dest_port = LWIP_IANA_PORT_MDNS;
+  SMEMCPY(&outmsg.dest_addr, destination, sizeof(outmsg.dest_addr));
+  res = mdns_send_outpacket(&outmsg, netif);
 
-cleanup:
-  if (pkt.pbuf) {
-    pbuf_free(pkt.pbuf);
-    pkt.pbuf = NULL;
-  }
   return res;
 }
 
@@ -2032,11 +1341,11 @@ mdns_probe(void* arg)
 #if LWIP_IPV4
     /*if ipv4 wait with probing until address is set*/
     if (!ip4_addr_isany_val(*netif_ip4_addr(netif)) &&
-        mdns_send_probe(netif, IP4_ADDR_ANY) == ERR_OK)
+        mdns_send_probe(netif, &v4group) == ERR_OK)
 #endif
     {
 #if LWIP_IPV6
-      if (mdns_send_probe(netif, IP6_ADDR_ANY) == ERR_OK)
+      if (mdns_send_probe(netif, &v6group) == ERR_OK)
 #endif
       {
         mdns->probes_sent++;
@@ -2053,11 +1362,10 @@ mdns_probe(void* arg)
  * @param hostname Name to use. Queries for &lt;hostname&gt;.local will be answered
  *                 with the IP addresses of the netif. The hostname will be copied, the
  *                 given pointer can be on the stack.
- * @param dns_ttl Validity time in seconds to send out for IP address data in DNS replies
  * @return ERR_OK if netif was added, an err_t otherwise
  */
 err_t
-mdns_resp_add_netif(struct netif *netif, const char *hostname, u32_t dns_ttl)
+mdns_resp_add_netif(struct netif *netif, const char *hostname)
 {
   err_t res;
   struct mdns_host *mdns;
@@ -2073,10 +1381,22 @@ mdns_resp_add_netif(struct netif *netif, const char *hostname, u32_t dns_ttl)
   netif_set_client_data(netif, mdns_netif_client_id, mdns);
 
   MEMCPY(&mdns->name, hostname, LWIP_MIN(MDNS_LABEL_MAXLEN, strlen(hostname)));
-  mdns->dns_ttl = dns_ttl;
   mdns->probes_sent = 0;
   mdns->probing_state = MDNS_PROBING_NOT_STARTED;
 
+  /* Init delayed message structs with address and port */
+#if LWIP_IPV4
+  mdns->ipv4.delayed_msg_multicast.dest_port = LWIP_IANA_PORT_MDNS;
+  SMEMCPY(&mdns->ipv4.delayed_msg_multicast.dest_addr, &v4group,
+            sizeof(ip_addr_t));
+#endif
+
+#if LWIP_IPV6
+  mdns->ipv6.delayed_msg_multicast.dest_port = LWIP_IANA_PORT_MDNS;
+  SMEMCPY(&mdns->ipv6.delayed_msg_multicast.dest_addr, &v6group,
+            sizeof(ip_addr_t));
+#endif
+
   /* Join multicast groups */
 #if LWIP_IPV4
   res = igmp_joingroup_netif(netif, ip_2_ip4(&v4group));
@@ -2182,14 +1502,13 @@ mdns_resp_rename_netif(struct netif *netif, const char *hostname)
  * @param proto The service protocol, DNSSD_PROTO_TCP for TCP ("_tcp") and DNSSD_PROTO_UDP
  *              for others ("_udp")
  * @param port The port the service listens to
- * @param dns_ttl Validity time in seconds to send out for service data in DNS replies
  * @param txt_fn Callback to get TXT data. Will be called each time a TXT reply is created to
  *               allow dynamic replies.
  * @param txt_data Userdata pointer for txt_fn
  * @return service_id if the service was added to the netif, an err_t otherwise
  */
 s8_t
-mdns_resp_add_service(struct netif *netif, const char *name, const char *service, enum mdns_sd_proto proto, u16_t port, u32_t dns_ttl, service_get_txt_fn_t txt_fn, void *txt_data)
+mdns_resp_add_service(struct netif *netif, const char *name, const char *service, enum mdns_sd_proto proto, u16_t port, service_get_txt_fn_t txt_fn, void *txt_data)
 {
   s8_t i;
   s8_t slot = -1;
@@ -2222,7 +1541,6 @@ mdns_resp_add_service(struct netif *netif, const char *name, const char *service
   srv->txt_userdata = txt_data;
   srv->proto = (u16_t)proto;
   srv->port = port;
-  srv->dns_ttl = dns_ttl;
 
   mdns->services[slot] = srv;
 
@@ -2328,11 +1646,23 @@ mdns_resp_announce(struct netif *netif)
   if (mdns->probing_state == MDNS_PROBING_COMPLETE) {
     /* Announce on IPv6 and IPv4 */
 #if LWIP_IPV6
-    mdns_announce(netif, IP6_ADDR_ANY);
+    mdns_announce(netif, &v6group);
+    mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT, mdns_multicast_timeout_reset_ipv6,
+                     &mdns->ipv6.multicast_timeout);
+    LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout started - IPv6\n"));
+    mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT_25TTL, mdns_multicast_timeout_25ttl_reset_ipv6,
+                     &mdns->ipv6.multicast_timeout_25TTL);
+    LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout 1/4 of ttl started - IPv6\n"));
 #endif
 #if LWIP_IPV4
     if (!ip4_addr_isany_val(*netif_ip4_addr(netif))) {
-      mdns_announce(netif, IP4_ADDR_ANY);
+      mdns_announce(netif, &v4group);
+      mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT, mdns_multicast_timeout_reset_ipv4,
+                       &mdns->ipv4.multicast_timeout);
+      LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout started - IPv4\n"));
+      mdns_set_timeout(netif, MDNS_MULTICAST_TIMEOUT_25TTL, mdns_multicast_timeout_25ttl_reset_ipv4,
+                       &mdns->ipv4.multicast_timeout_25TTL);
+      LWIP_DEBUGF(MDNS_DEBUG, ("MDNS: multicast timeout 1/4 of ttl started - IPv4\n"));
     }
 #endif
   } /* else: ip address changed while probing was ongoing? @todo reset counter to restart? */
@@ -2387,9 +1717,9 @@ mdns_resp_init(void)
   mdns_pcb = udp_new_ip_type(IPADDR_TYPE_ANY);
   LWIP_ASSERT("Failed to allocate pcb", mdns_pcb != NULL);
 #if LWIP_MULTICAST_TX_OPTIONS
-  udp_set_multicast_ttl(mdns_pcb, MDNS_TTL);
+  udp_set_multicast_ttl(mdns_pcb, MDNS_IP_TTL);
 #else
-  mdns_pcb->ttl = MDNS_TTL;
+  mdns_pcb->ttl = MDNS_IP_TTL;
 #endif
   res = udp_bind(mdns_pcb, IP_ANY_TYPE, LWIP_IANA_PORT_MDNS);
   LWIP_UNUSED_ARG(res); /* in case of LWIP_NOASSERT */
